#line 1318 "ped.nw"
#include "Ped.h"
#include <iostream>
#include <gtk--/box.h>
#include <gtk--/button.h>
#include <gtk--/main.h>
#include <gtk--/window.h>
using SigC::slot;
#line 1075 "ped.nw"
class AppWin;
class App
{
 public:
   App() : preUnique(false), preExists(false), _pPed(0), _mainWin(0) {};
   ~App() {delete _pPed;}
   
#line 1101 "ped.nw"
bool  getArgs(int& gtkArgc, char**& gtkArgv, int argc, char** argv)
{
   bool  ok = true;
   int   ai = 1;
   gtkArgc = argc;
   gtkArgv = argv;
   _title = "Ped"; // default
   while (ok && (ai < argc-1))
   {
      string  a(argv[ai]);
      if (a == string("-unique"))
      {
         preUnique = true;  ++ai;
      }
      else if (a == string("-exists"))
      {
         preExists = true;  ++ai;
      }
      else if (a == string("-gtk"))
      {
         gtkArgv = argv + ai;
         const string  egtk("-egtk");
         while ((++ai < argc-1) && (string(argv[ai]) != egtk));
         if (ok = (ai < argc-1) && (string(argv[ai]) == egtk))
         {
            gtkArgc = (argv + ai) - gtkArgv;
         }
      }
      else if (a == string("-title"))
      {
         _title = argv[++ai];  ++ai;
      }
      else
      {
         ok = false;
      }
   }
   if (ok = ok && (ai == argc-1))
   {
      pathArg = string(argv[ai]);
   }
   return ok;
}
#line 1082 "ped.nw"
   void build();
   void quit();
   void printOriginal() { cout << pathArg << endl; }

 private:
   
#line 1188 "ped.nw"
void print()
{
   cout << _pPed->result() << endl;
}
#line 1196 "ped.nw"
void printQuit()
{
   print();
   quit();
}
#line 1205 "ped.nw"
void printOriginalQuit()
{
   printOriginal();
   quit();
}
#line 1088 "ped.nw"
   bool    preUnique;
   bool    preExists;
   string  pathArg;
   Ped*    _pPed;
   
#line 1177 "ped.nw"
string  _title;
#line 1223 "ped.nw"
AppWin*  _mainWin;
#line 1093 "ped.nw"
};
#line 1247 "ped.nw"
class AppButton : public Gtk::Button
{
 public:
   AppButton(App& app, void (App::*f)(), const string& label) :
      Gtk::Button(label), _app(app), _f(f) {}
   virtual ~AppButton() {}
 private:
   void clicked_impl() { (_app.*_f)(); }
   App&  _app;
   void (App::*_f)();
};
#line 1267 "ped.nw"
class AppWin: public Gtk::Window
{
 public:
   AppWin(App& app) : Gtk::Window(GTK_WINDOW_TOPLEVEL), _app(app) {};
   virtual ~AppWin() {};
   virtual gint delete_event_impl(GdkEventAny*)
   {
      _app.printOriginal();
      Gtk::Main::quit();
      return 0;
   }
 private:
   App& _app;
};
#line 1151 "ped.nw"
void App::build()
{
   // app._pPed = new Ped(app.pathArg);
   _pPed = new Ped(pathArg, preUnique, preExists);
   _mainWin = new AppWin(*this);
   _mainWin->set_usize(400, 300);
   _mainWin->set_title(_title);

   Gtk::VBox*  vbox = manage(new Gtk::VBox(false, 0));
   Gtk::HBox*  hbox = manage(new Gtk::HBox(true, 0));
   AppButton*  okButton =
               manage(new AppButton(*this, &App::printQuit, "OK"));
   AppButton*  cancelButton =
               manage(new AppButton(*this, &App::printOriginalQuit, "Cancel"));
   hbox->pack_start(*okButton,     true, true, 64);
   hbox->pack_start(*cancelButton, true, true, 64);

   vbox->pack_start(*(_pPed->box()));
   vbox->pack_start(*hbox, false, false, 6);
   _mainWin->add(*vbox);

   _mainWin->show_all();
}
#line 1216 "ped.nw"
void App::quit()
{
   delete _mainWin;   _mainWin = 0;
   Gtk::Main::quit();
}
#line 1232 "ped.nw"
static void usage()
{
   cerr << "Usage: ped [-unique] [-exists]" << endl <<
           "           [-title <Title>] [-gtk gtkargs -egtk] <path>" << endl;
}
#line 1050 "ped.nw"
int main(int argc, char** argv)
{
   App     app;
   int     gArgc;
   char**  gArgv;
   bool  ok = app.getArgs(gArgc, gArgv, argc, argv);
   if (ok)
   {
      Gtk::Main      main(gArgc, gArgv);
      app.build();
      main.run();
   }
   else
   {
      usage();
   }
   return !ok;
}
